// Generated by the protocol buffer compiler.  DO NOT EDIT!
// source: google/devtools/remoteexecution/v1test/remote_execution.proto

package com.google.devtools.remoteexecution.v1test;

/**
 * <pre>
 * The precondition violation types that may be reported (in string form) in the
 * `type` field of a [Violation][google.rpc.PreconditionFailure.Violation], in
 * response to a call to [Execute][]. Most errors will specify additional detail
 * about the violation in the `subject` field of the `Violation`.
 * </pre>
 *
 * Protobuf enum {@code google.devtools.remoteexecution.v1test.ExecutePreconditionViolationType}
 */
public enum ExecutePreconditionViolationType
    implements com.google.protobuf.ProtocolMessageEnum {
  /**
   * <code>UNKNOWN = 0;</code>
   */
  UNKNOWN(0),
  /**
   * <pre>
   * A requested input (or the [Command][] of the [Action][]) was not found in
   * the [ContentAddressableStorage][].
   * </pre>
   *
   * <code>MISSING_INPUT = 1;</code>
   */
  MISSING_INPUT(1),
  /**
   * <pre>
   * One of the input [Directories][Directory] has multiple entries with the
   * same file name. This will also occur if the worker filesystem considers
   * two names to be the same, such as two names that vary only by case on a
   * case-insensitive filesystem, or two names with the same normalized form on
   * a filesystem that performs Unicode normalization on filenames.
   * </pre>
   *
   * <code>DUPLICATE_FILE_NODE = 2;</code>
   */
  DUPLICATE_FILE_NODE(2),
  /**
   * <pre>
   * One of the input [PathNodes][PathNode] has an invalid name, such as a name
   * containing a `/` character or another character which cannot be used in a
   * file's name on the filesystem of the worker.
   * </pre>
   *
   * <code>INVALID_FILE_NAME = 3;</code>
   */
  INVALID_FILE_NAME(3),
  /**
   * <pre>
   * The files in an input [Directory][] are not correctly sorted by `name`.
   * </pre>
   *
   * <code>DIRECTORY_NOT_SORTED = 4;</code>
   */
  DIRECTORY_NOT_SORTED(4),
  /**
   * <pre>
   * The [Command][]'s `environment_variables` are not correctly sorted by
   * `name`.
   * </pre>
   *
   * <code>ENVIRONMENT_VARIABLES_NOT_SORTED = 5;</code>
   */
  ENVIRONMENT_VARIABLES_NOT_SORTED(5),
  /**
   * <pre>
   * The [Command][]'s `environment_variables` contain a duplicate entry. On
   * systems where environment variables may consider two different names to be
   * the same, such as if environment variables are case-insensitive, this may
   * also occur if two equivalent environment variables appear.
   * </pre>
   *
   * <code>DUPLICATE_ENVIRONMENT_VARIABLE = 6;</code>
   */
  DUPLICATE_ENVIRONMENT_VARIABLE(6),
  /**
   * <pre>
   * The input file tree contains a cycle (a [Directory][] which, directly or
   * indirectly, contains itself).
   * </pre>
   *
   * <code>DIRECTORY_CYCLE_DETECTED = 7;</code>
   */
  DIRECTORY_CYCLE_DETECTED(7),
  /**
   * <pre>
   * No worker is available which matches the requested [Platform][].
   * </pre>
   *
   * <code>NO_WORKER = 8;</code>
   */
  NO_WORKER(8),
  /**
   * <pre>
   * A `Digest` in the input tree is invalid.
   * </pre>
   *
   * <code>INVALID_DIGEST = 9;</code>
   */
  INVALID_DIGEST(9),
  UNRECOGNIZED(-1),
  ;

  /**
   * <code>UNKNOWN = 0;</code>
   */
  public static final int UNKNOWN_VALUE = 0;
  /**
   * <pre>
   * A requested input (or the [Command][] of the [Action][]) was not found in
   * the [ContentAddressableStorage][].
   * </pre>
   *
   * <code>MISSING_INPUT = 1;</code>
   */
  public static final int MISSING_INPUT_VALUE = 1;
  /**
   * <pre>
   * One of the input [Directories][Directory] has multiple entries with the
   * same file name. This will also occur if the worker filesystem considers
   * two names to be the same, such as two names that vary only by case on a
   * case-insensitive filesystem, or two names with the same normalized form on
   * a filesystem that performs Unicode normalization on filenames.
   * </pre>
   *
   * <code>DUPLICATE_FILE_NODE = 2;</code>
   */
  public static final int DUPLICATE_FILE_NODE_VALUE = 2;
  /**
   * <pre>
   * One of the input [PathNodes][PathNode] has an invalid name, such as a name
   * containing a `/` character or another character which cannot be used in a
   * file's name on the filesystem of the worker.
   * </pre>
   *
   * <code>INVALID_FILE_NAME = 3;</code>
   */
  public static final int INVALID_FILE_NAME_VALUE = 3;
  /**
   * <pre>
   * The files in an input [Directory][] are not correctly sorted by `name`.
   * </pre>
   *
   * <code>DIRECTORY_NOT_SORTED = 4;</code>
   */
  public static final int DIRECTORY_NOT_SORTED_VALUE = 4;
  /**
   * <pre>
   * The [Command][]'s `environment_variables` are not correctly sorted by
   * `name`.
   * </pre>
   *
   * <code>ENVIRONMENT_VARIABLES_NOT_SORTED = 5;</code>
   */
  public static final int ENVIRONMENT_VARIABLES_NOT_SORTED_VALUE = 5;
  /**
   * <pre>
   * The [Command][]'s `environment_variables` contain a duplicate entry. On
   * systems where environment variables may consider two different names to be
   * the same, such as if environment variables are case-insensitive, this may
   * also occur if two equivalent environment variables appear.
   * </pre>
   *
   * <code>DUPLICATE_ENVIRONMENT_VARIABLE = 6;</code>
   */
  public static final int DUPLICATE_ENVIRONMENT_VARIABLE_VALUE = 6;
  /**
   * <pre>
   * The input file tree contains a cycle (a [Directory][] which, directly or
   * indirectly, contains itself).
   * </pre>
   *
   * <code>DIRECTORY_CYCLE_DETECTED = 7;</code>
   */
  public static final int DIRECTORY_CYCLE_DETECTED_VALUE = 7;
  /**
   * <pre>
   * No worker is available which matches the requested [Platform][].
   * </pre>
   *
   * <code>NO_WORKER = 8;</code>
   */
  public static final int NO_WORKER_VALUE = 8;
  /**
   * <pre>
   * A `Digest` in the input tree is invalid.
   * </pre>
   *
   * <code>INVALID_DIGEST = 9;</code>
   */
  public static final int INVALID_DIGEST_VALUE = 9;


  public final int getNumber() {
    if (this == UNRECOGNIZED) {
      throw new java.lang.IllegalArgumentException(
          "Can't get the number of an unknown enum value.");
    }
    return value;
  }

  /**
   * @deprecated Use {@link #forNumber(int)} instead.
   */
  @java.lang.Deprecated
  public static ExecutePreconditionViolationType valueOf(int value) {
    return forNumber(value);
  }

  public static ExecutePreconditionViolationType forNumber(int value) {
    switch (value) {
      case 0: return UNKNOWN;
      case 1: return MISSING_INPUT;
      case 2: return DUPLICATE_FILE_NODE;
      case 3: return INVALID_FILE_NAME;
      case 4: return DIRECTORY_NOT_SORTED;
      case 5: return ENVIRONMENT_VARIABLES_NOT_SORTED;
      case 6: return DUPLICATE_ENVIRONMENT_VARIABLE;
      case 7: return DIRECTORY_CYCLE_DETECTED;
      case 8: return NO_WORKER;
      case 9: return INVALID_DIGEST;
      default: return null;
    }
  }

  public static com.google.protobuf.Internal.EnumLiteMap<ExecutePreconditionViolationType>
      internalGetValueMap() {
    return internalValueMap;
  }
  private static final com.google.protobuf.Internal.EnumLiteMap<
      ExecutePreconditionViolationType> internalValueMap =
        new com.google.protobuf.Internal.EnumLiteMap<ExecutePreconditionViolationType>() {
          public ExecutePreconditionViolationType findValueByNumber(int number) {
            return ExecutePreconditionViolationType.forNumber(number);
          }
        };

  public final com.google.protobuf.Descriptors.EnumValueDescriptor
      getValueDescriptor() {
    return getDescriptor().getValues().get(ordinal());
  }
  public final com.google.protobuf.Descriptors.EnumDescriptor
      getDescriptorForType() {
    return getDescriptor();
  }
  public static final com.google.protobuf.Descriptors.EnumDescriptor
      getDescriptor() {
    return com.google.devtools.remoteexecution.v1test.RemoteExecutionProto.getDescriptor().getEnumTypes().get(0);
  }

  private static final ExecutePreconditionViolationType[] VALUES = values();

  public static ExecutePreconditionViolationType valueOf(
      com.google.protobuf.Descriptors.EnumValueDescriptor desc) {
    if (desc.getType() != getDescriptor()) {
      throw new java.lang.IllegalArgumentException(
        "EnumValueDescriptor is not for this type.");
    }
    if (desc.getIndex() == -1) {
      return UNRECOGNIZED;
    }
    return VALUES[desc.getIndex()];
  }

  private final int value;

  private ExecutePreconditionViolationType(int value) {
    this.value = value;
  }

  // @@protoc_insertion_point(enum_scope:google.devtools.remoteexecution.v1test.ExecutePreconditionViolationType)
}

